from pynput import keyboard
import serial
import time

ser = serial.Serial('/dev/serial0', 9600, timeout=1)

speed = 0

deg = 80

def send_command(device, RL_rpm, RR_rpm, FL_rpm, FR_rpm, RLdeg, RRdeg, FLdeg, FRdeg):
    command = f"{device} {RL_rpm} {RR_rpm} {FL_rpm} {FR_rpm} {RLdeg} {RRdeg} {FLdeg} {FRdeg}"
    ser.write(command.encode())  # Encode the string to bytes
    print(f"Sent: {command}")
    time.sleep(0.045)



def on_press(key):
    global speed  # Declare speed as global to modify it inside this function
    try:
        if key.char == 'w':
            print("W key was pressed")
            send_command("m", speed, speed, speed, speed, 0, 0, 0, 0)  # Move forward
        elif key.char == 'a':
            print("A key was pressed")
            send_command("m", speed, -speed, -speed, speed, 0, 0, 0, 0)  # Move left
        elif key.char == 's':
            print("S key was pressed")
            send_command("m", -speed, -speed, -speed, -speed, 0, 0, 0, 0)  # Move backward
        elif key.char == 'd':
            print("D key was pressed")
            send_command("m", -speed, speed, speed, -speed, 0, 0, 0, 0)  # Move right
        elif key.char == 'q':
            print("Q key was pressed")
            send_command("m", -speed, speed, -speed, speed, 0, 0, 0, 0)  # Rotate counterclockwise
        elif key.char == 'e':
            print("E key was pressed")
            send_command("m", speed, -speed, speed, -speed, 0, 0, 0, 0)  # Rotate clockwise
        elif key.char == '1':
            print("1 key was pressed")
            speed = 20
        elif key.char == '2':
            print("2 key was pressed")
            speed = 40
        elif key.char == '3':
            print("3 key was pressed")
            speed = 60
        elif key.char == '4':
            print("4 key was pressed")
            speed = 80
        elif key.char == '5':
            print("5 key was pressed")
            speed = 100
        elif key.char == '6':
            print("5 key was pressed")
            speed = 120
        elif key.char == '7':
            print("5 key was pressed")
            speed = 140
        elif key.char == '8':
            print("5 key was pressed")
            speed = 160
        elif key.char == '9':
            print("5 key was pressed")
            speed = 180
        elif key.char == '0':
            print("0 key was pressed")
            speed = 0
        elif key.char == 'l':
            print("Right arrow key was pressed")
            send_command("s", 0, 0, 0, 0, 0, deg, 0, deg)  # Move right
        elif key.char == 'j':
            print("Right arrow key was pressed")
            send_command("s", 0, 0, 0, 0, deg, 0, deg, 0)  # Move right
        elif key.char == 'k':
            print("Right arrow key was pressed")
            send_command("s", 0, 0, 0, 0, deg, deg, 0, 0)  # Move right
        elif key.char == 'i':
            print("Right arrow key was pressed")
            send_command("s", 0, 0, 0, 0, 0, 0, deg, deg)  # Move right
        
    except AttributeError:
        # This will handle special keys that don't have a char attribute
        pass

def on_release(key):
    # Stop the robot if any key is released
    time.sleep(0.1)
    command = f"m 0 0 0 0 0 0 0 0"
    ser.write(command.encode())  # Encode the string to bytes
    time.sleep(0.1)
    command = f"s 0 0 0 0 0 0 0 0"
    ser.write(command.encode())  # Encode the string to bytes
    print(f"Sent: {command}")
    if key == keyboard.Key.esc:
        return False

# Create an instance of Listener
with keyboard.Listener(on_press=on_press, on_release=on_release) as listener:
    print("Listening for inputs")
    listener.join()