import time
from servo import Servo
from machine import UART, Pin

uart = UART(0, baudrate=9600, tx=Pin(16), rx=Pin(17))


RLA = Servo(pin_id=0)
RLB = Servo(pin_id=1)

RRA = Servo(pin_id=2)
RRB = Servo(pin_id=3)

FLA = Servo(pin_id=7)
FLB = Servo(pin_id=8)

FRB = Servo(pin_id=5)
FRA = Servo(pin_id=6)

RLdeg = 0
RRdeg = 0
FLdeg = 0
FRdeg = 0



print("Listening for UART messages...")

while True:
    if uart.any():
        message = uart.read().decode().strip() # remove

        try:
            # Split and convert message to individual RPM values
            device, iRLsetpointRPM, iRRsetpointRPM, iFLsetpointRPM, iFRsetpointRPM, iRLdeg, iRRdeg, iFLdeg, iFRdeg = message.split()
    
            print(message)
            if device == "s":
                RLdeg = int(iRLdeg)
                RRdeg = int(iRRdeg)
                FLdeg = int(iFLdeg)
                FRdeg = int(iFRdeg)
            else:
                print("not for me")

        except ValueError:
            print("Invalid UART message format. Expected 8 numbers.")
    
    
    RLA.write(RLdeg)
    RLB.write(180-RLdeg)
    
    RRA.write(178-RRdeg)
    RRB.write(RRdeg)
    
    FLA.write(FLdeg)
    FLB.write(180-FLdeg)
    
    FRA.write(FRdeg)
    FRB.write(180-FRdeg)
    
    time.sleep(0.01)




